<template>
    <v-card color="grey lighten-5">
        <v-card-title>
            <v-btn
                @click="clear"
                :disabled="loading"
                color="white"
                small
            >{{ $t('clear') }}</v-btn>
            <v-spacer></v-spacer>
            <v-btn
                :disabled="loading"
                @click="$emit('confirmed')"
                color="primary"
                small
            >{{ $t('confirm') }}</v-btn>
        </v-card-title>
        <v-card-text>
            <v-list>
                <div v-if="loading" class="d-flex justify-center">
                    <v-progress-circular indeterminate color="primary"></v-progress-circular>
                </div>
                <v-list-group
                    v-else
                    v-for="selection in selections"
                    :key="selection.text"
                    :prepend-icon="selection.icon"
                >
                    <template v-slot:activator>
                        <v-list-item-title>{{ selection.text }}</v-list-item-title>
                    </template>

                    <v-list-item-group
                        v-model="selectedRoles"
                        multiple
                    >
                        <v-list-item
                            v-for="role in selectableRoles"
                            :key="role.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ role.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>
                </v-list-group>
            </v-list>
        </v-card-text>
    </v-card>
</template>

<script>
    export default {
        name: 'AccountFilters',
        props: ['roles'],
        data: () => ({
            loading: false,
            selectableRoles: [],
            selectedRoles: []
        }),
        computed: {
            selections() {
                return [
                    {
                        text: this.$t('role'),
                        icon: 'mdi-account-circle',
                        active: false
                    }
                ]
            }
        },
        watch: {
            selectedRoles(ids) {
                const map = ids.map(id => {
                    return this.selectableRoles[id].id
                });
                this.$emit('update:roles', map);
            }
        },
        created() {
            this.loading = true;

            axios.get('api/roles')
                .then(({ data }) => {
                    this.selectableRoles = data;
                })
                .catch(error => {
                })
                .finally(() => {
                    this.loading = false
                })
        },
        methods: {
            clear() {
                this.selectedRoles = [];
                this.selections.forEach(selection => {
                    selection.active = false;
                })
                this.$emit('update:roles', []);
            }
        }
    }
</script>

<style scoped>

</style>
